Home
Search all pages
Subjects
By activity
Professions, Sciences, Humanities, Business, ...
User Interface
Text-based, GUI, Audio, Video, Keyboards, Mouse, Images,...
Text Strings
Conversions, tests, processing, manipulation,...
Math
Integer, Floating point, Matrix, Statistics, Boolean, ...
Processing
Algorithms, Memory, Process control, Debugging, ...
Stored Data
Data storage, Integrity, Encryption, Compression, ...
Communications
Networks, protocols, Interprocess, Remote, Client Server, ...
Hard World Timing, Calendar and Clock, Audio, Video, Printer, Controls...
File System
Management, Filtering, File & Directory access, Viewers, ...
|
|
|
RocketLink!--> Man page versions:
OpenBSD
FreeBSD
RedHat
Others
MKTEMP(1) OpenBSD Reference Manual MKTEMP(1)
NAME
mktemp - make temporary file name (unique)
SYNOPSIS
mktemp [-d] [-q] [-u] template
DESCRIPTION
The mktemp utility takes the given file name template and overwrites a
portion of it to create a file name. This file name is unique and suit-
able for use by the application. The template may be any file name with
some number of `Xs' appended to it, for example /tmp/temp.XXXXXXXXXX. The
trailing `Xs' are replaced with the current process number and/or a
unique letter combination. The number of unique file names mktemp can
return depends on the number of `Xs' provided; six `Xs' will result in
mktemp testing roughly 26 ** 6 combinations.
If mktemp can successfully generate a unique file name, the file is cre-
ated with mode 0600 (unless the -u flag is given) and the filename is
printed to standard output.
mktemp is provided to allow shell scripts to safely use temporary files.
Traditionally, many shell scripts take the name of the program with the
PID as a suffix and use that as a temporary file name. This kind of nam-
ing scheme is predictable and the race condition it creates is easy for
an attacker to win. A safer, though still inferior approach is to make a
temporary directory using the same naming scheme. While this does allow
one to guarantee that a temporary file will not be subverted, it still
allows a simple denial of service attack. For these reasons it is sug-
gested that mktemp be used instead.
OPTIONS
The available options are as follows:
-d Make a directory instead of a file.
-q Fail silently if an error occurs. This is useful if a script
does not want error output to go to standard error.
-u Operate in ``unsafe'' mode. The temp file will be unlinked be-
fore mktemp exits. This is slightly better than mktemp(3) but
still introduces a race condition. Use of this option is not en-
couraged.
RETURN VALUES
The mktemp utility exits with a value of 0 on success or 1 on failure.
EXAMPLES
The following sh(1) fragment illustrates a simple use of mktemp where the
script should quit if it cannot get a safe temporary file.
TMPFILE=`mktemp /tmp/$0.XXXXXXXXXX` || exit 1
echo "program output" >> $TMPFILE
In this case, we want the script to catch the error ourselves.
TMPFILE=`mktemp -q /tmp/$0.XXXXXXXXXX`
if [ $? -ne 0 ]; then
echo "$0: Can't create temp file, exiting..."
exit 1
fi
Or perhaps you don't want to exit if mktemp is unable to create the file.
In this case you can protect the part of the script thusly.
TMPFILE=`mktemp /tmp/$0.XXXXXXXXXX` && {
# Safe to use $TMPFILE in this block
echo data > $TMPFILE
...
rm -f $TMPFILE
}
SEE ALSO
mkdtemp(3), mkstemp(3), mktemp(3)
HISTORY
The mktemp utility appeared in OpenBSD 2.1.
OpenBSD 2.6 November 20, 1996 2
Source: OpenBSD 2.6 man pages. Copyright: Portions are copyrighted by BERKELEY SOFTWARE DESIGN, INC., The Regents of the University of California, Massachusetts Institute of Technology, Free Software Foundation, FreeBSD Inc., and others. |
(Corrections, notes, and links courtesy of RocketAware.com)
FreeBSD Sources for mktemp(1) OpenBSD sources for mktemp(1)
Up to: File Access - Operations affecting a file as a whole. (delete files, rename, truncate, etc.)
Up to: Directory Access - Accessing directories of files, browsing, management, et al.
RocketLink!--> Man page versions:
OpenBSD
FreeBSD
RedHat
Others
Rapid-Links:
Search | About | Comments | Submit Path: RocketAware >
mktemp.1/
RocketAware.com is a service of Mib Software Copyright 1999, Forrest J. Cavalier III. All Rights Reserved. We welcome submissions and comments
|